#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdint.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "gpio_char.h" /* get the ioctl commands */

static int file_des = 0;

int main(int argc, char *argv[])
{
    uint32_t index;
    uint32_t data;

    if ((file_des = open("/dev/indexed_atod", O_RDWR)) == -1) {
        fprintf(stderr,"Error opening device file: %s\n", strerror(errno));
        return -1;
    }

    for(index=0;index<4;index++)
    {
         /* set the index */
        if (ioctl(file_des, INDEXWRITE, &index) == -1) {
            fprintf(stderr,"error setting index: %s\n", strerror(errno));
            return -1;
        }
        /* read the data */
        if (ioctl(file_des, DATAREAD, &data) == -1) {
            fprintf(stderr,"error reading data\n");
            return -1;
        }
	switch(index)
	{
	  case 0: printf("Temperature             = %lf C\t",((3.3*((double)data/1024.0))-.5)/ .01);
		  break;
	  case 1: printf("DC Power Supply Voltage = %lf V\t",15.0*((double)data/1024.0));
		  break;
	  case 2: printf("Standby Battery Voltage = %lf V\t",15.0*((double)data/1024.0));
		  break;
	  case 3: printf("Standby Battery Current = %lf A\t",2.0*((double)data/1024.0)-1.0);
		  break;

	}
	printf("(%x %lf)\n",data,3.3*((double)data/1024.0));
    }

    close(file_des);
    return 0;

}


